import wm from './lib/windowManager';
import { easeInOutQuad } from './lib/animations';
import { app } from 'electron';

app.on('ready', () => {
  try {
    const mw = wm.create({
      w: 10,
      h: 10,
      whp: true,
      onCreate: (win: any) => {
        win.loadURL('https://example.com');
      },
    });

    const wait = (ms: number) => new Promise(resolve => setTimeout(resolve, ms));

    (async () => {
      await wait(200);
      wm.resize({ id: mw, w: 25, h: 25, smooth: true, p: true, fromCenter: true, ease: easeInOutQuad});
      await wait(1000);
      wm.resize({ id: mw, w: 50, h: 50, smooth: true, p: true, fromCenter: true, ease: easeInOutQuad});
      await wait(650);
      wm.move({ id: mw, x: 0, y: 50, p: true, fromCenter: true});
      wm.resize({ id: mw, w: 33, h: 100, p: true });
      wm.resize({ id: mw, w: 33, h: 10, smooth: true, p: true, ease: easeInOutQuad, anchor: 'bottom'});
      await wait(500);
      wm.move({ id: mw, x: 50, y: 50, p: true, fromCenter: true});
      wm.resize({ id: mw, w: 33, h: 100, p: true });
      wm.resize({ id: mw, w: 33, h: 10, smooth: true, p: true, ease: easeInOutQuad, anchor: 'bottom'});
      await wait(500);
      wm.move({ id: mw, x: 100, y: 50, p: true, fromCenter: true});
      wm.resize({ id: mw, w: 33, h: 100, p: true });
      wm.resize({ id: mw, w: 33, h: 10, smooth: true, p: true, ease: easeInOutQuad, anchor: 'bottom'});
      await wait(500);
      wm.resize({ id: mw, w: 100, h: 100, smooth: true, p: true, fromCenter: true, ease: easeInOutQuad});
      await wait(550);
      wm.resize({ id: mw, w: 100, h: 10, smooth: true, p: true, ease: easeInOutQuad, anchor: 'bottom'});
      await wait(550);
      wm.resize({ id: mw, w: 33, h: 10, smooth: true, p: true, fromCenter: true, ease: easeInOutQuad, anchor: 'bottom'});
      await wait(500);
      wm.move({ id: mw, x: 50, y: 50, p: true, fromCenter: true, ease: easeInOutQuad, smooth: true});
      await wait(500);
      wm.resize({ id: mw, w: 50, h: 50, smooth: true, p: true, fromCenter: true, ease: easeInOutQuad});
      await wait(510);
      wm.eval(mw, `document.querySelector('body').innerHTML = '<h1>NeoFunkin</h1>'`);
      await wait(500);
      wm.eval(mw, `document.querySelector('body').innerHTML = '<h1>MrpGimlom</h1>'`);
      await wait(100);
      wm.eval(mw, `document.querySelector('body').innerHTML = '<h1>NeoFunkin: Window manager</h1>'`);
      await wait(500);
      wm.eval(mw, `document.querySelector('body').innerHTML = '<h1>NeoFunkin: Window manager</h1><br>DEMO BY @TRUE1ANN, NEOFUNKIN IS PROPERTY OF ASPER'`);
      await wait(1500);
      wm.eval(mw, `document.querySelector('body').innerHTML = '<h1>NeoFunkin: Window manager</h1><br>DEMO BY @TRUE1ANN, NEOFUNKIN IS PROPERTY OF ASPER<br><small>this took so much to do omfg</small>'`);
    })();

  } catch (e) {
    console.error(e);
  }
});